	CPU	z80
;*Heading Monitorprogramm LC80.3.0
;*Page 87

;********************************************************
;*	GUELTIGES LISTING ENTSPRECHEND			*
;*	BITMUSTER NUMMER 75 UND 76			*
;*	(BEI 2-ROM-VARIANTE [MARKE ROM?=2])		*
;********************************************************
;		VEREINBARUNGEN
;
ROM_: EQU 2				; EIN ROM -> 1
					; ZWEI ROM -> 2

;PIO-PORTS:

SEGMENT		EQU 0F4H		;AUSGABE-PORT SEGMENTANSTEUERUNG
PIO1AC		EQU 0F6H

DIGITAP		EQU 0F5H		;B2...B7=DIGITANST. UND TASTENMATRIX
					;B0=TAPE-IN, B1=TAPE-OUT
PIO1BC		EQU 0F7H

USERPORT	EQU 0F8H		;U8ER-PORT, FREI VERFUEGBAR
PIO2AC		EQU 0FAH

KEYIN		EQU 0F9H		;B4...B7=EINGAENGE TASTEN-ABFRAGE
					;B0...B3 FUER USER NUTZBAR
PIO2BC		EQU 0FBH

;CTC-ADRESSEN
CTC0		EQU 0ECH
CTC1		EQU 0EDH
CTC2		EQU 0EEH
CTC3		EQU 0EFH

;VEREINBARUNGEN BEI ERWEITERUNGEN
INTVEK		EQU 00H			;INT-VECT. FUER CTC	lo(INTTAF)
HIINT		EQU 23H			;CPU-I-REG		hi(INTTAF)


;*****************************************************
;
		ORG 0000H
START:
		LD B,00H		;EINSCHALTVERZOEGERUNG
		DJNZ $
		JR BEGIN

		ORG 08H
RST1:
		JP 2308H

		ORG 10H
RST2:
		JP 2310H

		ORG 18H
RST3:
		JP 2318H

		ORG 20H
RST4:
		JP 2320H

		ORG 28H
RST5:
		JP 2328H

		ORG 30H
RST6:
		JP 2330H

		ORG 38H
RST7:
		JP 2338H

;-----------------------------------------------------
BEGIN:
		LD A,(INIFLAG)		;RAM LOESCHEN, WENN ERSTEINSCHALTUNG
		CP 80H			;schon init?
		JR Z,NOFF		;Ja, dann zu NOFF
		LD HL,2000H		;4K RAM lschen (mit FF fllen)
		LD DE,2001H
		LD BC,0FFFH
		LD (HL),0FFH
		LDIR
		LD BC,RSTLGT		;STANDARD-RST38-PROG. LADEN
		LD DE,2338H		;
		LD HL,RSTUP
		LDIR
		LD BC,NMILGT		;STANDARD-NMI-PROG. LADEN
		LD DE,2340H
		LD HL,NMIUP
		JR NMI+3		;weiter nach NMI-Einsprung

;-------------------- NMI-FKT. ANSPRINGEN ----------
		ORG 0066H
NMI:
		JP 2340H

;---------------------------------------------------------
		LDIR
NOFF:
		LD SP,SPINI		;SP AUF ANFANGSWERT
		CALL IOINIT
		CALL MEMTES
;--------------------- TEST, OB ERSTEINSCHALTUNG ----
		LD A,(INIFLAG)
		CP 80H
		CALL NZ,INI		;MUSIK U. GRAPHIK, WENN ERSTEINSCH.
;--------------------- RESETZUSTAND HERSTELLEN ------
		LD HL,2000H
		LD (USERPC),HL		;USER-PC AUF ANFANGSWERT
		XOR A
		LD (FUFEFLAG),A		;FUNKTIONS- UND FEHLERFLAG LOESCHEN
		LD IX,DISP1		; "LC80"-TEXT
;--------------------- TEXT, ADR.- U. TAPE-CODE LOE.
SETSTO:
		XOR A
		LD (ATCODE),A		; Funktionscode lschen

;--------------------- HAUPTPROGRAMM ----------------
MAIN:
		LD SP,SPINI		;USER-PC AUF ANFANGSWERT
		CALL DAK1		;ANZEIGE UND TASTATURABFRAGE
		CALL KEYEXC		;TASTENBEHANDLUNG
		JR MAIN

;--------------------- SPEICHERTEST ------------------
MEMTES:					;memory test
		LD BC,0004H		;1 K RAM
		LD HL,2000H		;ADR RAM
RAMSL:					;RAM-Schleife
		CALL RAMCHK		;TEST, OB (HL) RAM IST
		JR Z, RAMOK
		HALT			;HALT bei RAM-Fehler (rote LED)
RAMOK:
		INC HL
		DJNZ RAMSL		;256 Byte
		DEC C
		JR NZ,RAMSL		;4x256 Byte
		XOR A			;Prfsumme := 0
		LD HL,0			;ADR 1. ROM/EPROM
		LD BC,0004H		;1 K
		CALL ROMSL

		IF ROM_=1
		LD HL,0400H		;WEITER 1. ROM
		ENDIF

		IF ROM_=2
		LD HL,0800H		;ADR 2. ROM
		ENDIF

		LD BC,0FF04H		;1K - 1BYTE
		CALL ROMSL
		CP (HL)			;Vergleich mit letztem Byte (Prfwert im ROM)
		RET Z			;wenn gleich
		HALT			;sonst Fehler (rote LED)
		RET

ROMSL:					; ROM-Schleife
		ADD A,(HL)		;Prfsumme aufsaldieren
		INC HL
		DJNZ ROMSL
		DEC C
		JR NZ,ROMSL
		RET

;---------------------- IO-INITIALISIERUNG -----------
IOINIT:					;PIO-INITIALISIERUNG
		LD A,0CFH		;MODE 3
		OUT (PIO1AC),A		;SEGMENT-PORT
		LD A,0FFH
		OUT (SEGMENT),A		;ALLE SEGMENTE AUSSCHALTEN
		LD A,0			;E-A-DEFINITION
		OUT (PIO1AC),A

		LD A,0CFH
		OUT (PIO1BC),A		;DIGIT-AUSG.
					;B2...B7 = D-LSD,D-MSD,A-LSD...A-MSD
		LD A,0FFH		;ALLE TREIBER SPERREN
		OUT (DIGITAP),A
		LD A,1			;B0-EINGANG, B1...B7-AUSGAENGE
		OUT (PIO1BC),A

		LD A,0CFH
		OUT (PIO2BC),A		;TASTEN-EINGAENGE B4...B7
		LD A,0FFH
		OUT (PIO2BC),A
		RET

;-----------------------------------------------------
NMIUP:					;NMI-UNTERPROGRAMM
		JP NMIUP1
NMILGT 		EQU $-NMIUP		;up length

NMIUP1:
		PUSH AF			;Register sichern
		PUSH BC
		EX AF,AF'		;'
		EXX
		PUSH AF
		PUSH BC
		PUSH DE
		PUSH HL
		EXX
		PUSH IX
		LD B,40			;ANZEIGEZEIT "INT"
		LD IX,DISP5		;Text " int "
NMISL:					;NMI-Schleife
		CALL DAK2		;Anzeigen
		DJNZ NMISL
		POP IX
		EXX
		POP HL			;Register restaurieren
		POP DE
		POP BC
		POP AF
		EXX
		EX AF,AF'		;'
		POP BC
		POP AF
		RETN

;-----------------------------------------------------
RSTUP:
		JP RSTUP1
RSTLGT 		EQU $-RSTUP		; up length

RSTUP1:
		LD IX,DISP6		; "rst 38"
		JP SETSTO		; Spr. zum Hauptprogramm

;--------------------- TASTENBEHANDLUNGSPROGRAMM ----
;			EINTRITT: INTERNER TASTENCODE IN A

; "0".."F" 00..0F
; "+" 10, "-" 11, "EX" 12, "DAT" 14
; "ADR" 19, "ST" 1E, "LD" 1F

KEYEXC:
		CP 10H			;TEST, OB FUNKTIONSTASTE
		JR C,KHEX		;SPR., WENN ZIFFERNTASTE
		LD HL,FUFEFLAG		;FLAG "FUNKTIONSTASTE" SETZEN
		SET 0,(HL)
		SUB 10H			;OBERE ZIFFER DES CODES LOESCHEN
		CP 08H			;TEST DER FUNKTIONSGRUPPE
		LD HL,KSUFUN
		JP C,BRANCH		; WENN "+","-","EXEC" O. "DATA"-TASTE

					;ADR- ODER TAPE-TASTEN
		LD IX,DATLED		;ADR. FUER DATEN- U. ADR.-ANZEIGE
		SUB 08H
		LD HL,ATCODE
		LD (HL),A		;UMGERECHN. CODE HINTERLEGEN
					;1-ADR,6-ST,7-LD
		LD HL,ATFLAG
		LD (HL),0		;FLAG LOESCHEN
		LD HL,KFUN		;Funktionen ADR,ST,LD
		JP BRANCH

;----------------- AUSWERTUNG ZIFFERNTASTEN ---------
KHEX:
		LD C,A			;TASTATURCODE UMSPEICHERN
		LD HL,HTAB		;Funkionen nach Zifferntaste
BR1:
		LD A,(ATCODE)		;WERT FUER AUSZUF. FUNKTION
		JP BRANCH

;--------------------- EINTR.PKTE FUER +,-,EXEC,DATA -
;			(UEBER KSUFUN-TABELLE)
KINC:					; "+"-TASTE
		LD HL,ITAB		;Funktionen nach "+"
		JR BR1

KDEC:					; "-"-TASTE
		LD HL,DTAB		;Funktionen nach "-"
		JR BR1

KEXEC:					; "EXEC"-TASTE
		LD HL, ETAB		;Funktionen nach "EX"
		JR BR1

KDATA:					; "DATA"-TASTE
		CALL TESTM		;TEST. OB ADR OD. DAT IN ATCODE
		CALL MEMDP2		;ADR U. DAT. ANZ., DAT. GEPUNKTET
		RET

;--------------------- EINTR.PKTE FUER ADRS U. TAPE -
;			(UEBER KFUN-TABELLE)
KADRS:					; "ADRS"-TASTE
		CALL MEMDP1		;ADR. U. DAT. ANZ., ADR. GEPUNKTET
		RET

KTAPWR:					; "TO TAPE"- ODER "FROM TAPE"-TASTE
		CALL STEPDP		;PARAMETER ANZEIGEN
		RET

;--------------------- EINTR.PKTE FUER ZIFFERNEINGABEN
;			(UEBER HTAB-TABELLE)
HFIX:					; BEDIENUNGSFEHLER
		JP ERRDIS

HDA:					;ZIFFER ALS DATUM
		LD HL,(USERPC)
		CALL RAMCHK		;TEST, OB USER-PC IM RAM-BEREICH
		JP NZ,ERRDIS		;SPR., WENN KEIN RAM
		CALL PRECL1		;1 BYTE LOE., WENN FUFEFLAG NICHT 0
		LD A,C			;EINGEG. ZIFFER
		RLD			;TETRADE IN RAM SCHIEBEN
		CALL MEMDP2		;ANZEIGEN
		RET

HAD:					;ZIFFER ALS ADRESSE
		LD HL,USERPC
		CALL PRECL2		;2 BYTE LOE., WENN FUFEFLAG NICHT 0
		LD A,C			;EINGEG. ZIFFER
		RLD			;TETRADEN IN BEIDEN BYTE VERSCHIEBEN
		INC HL
		RLD
		CALL MEMDP1		;ANZEIGEN
		RET

HTAPWR:					;ZIFFER ALS PARAMETER FUER BAND
		CALL LOCTBF		;ADR FUER PARAMETER BERECHNEN
		CALL PRECL2		;2 BYTE LOE., WENN FUFEFLAG NICHT 0
		LD A,C			;EINGEG. ZIFFER
		RLD			;TETRADE IN BEIDEN BYTE VERSCHIEBEN
		INC HL
		RLD
		CALL STEPDP		;PARAMETER ANZEIGEN
		RET

;---------------------- UNTEREINTRITT "+"-TASTE ----
;			(UEBER ITAB)
IFIX:					;BEDIENUNGSFEHLER
		JP ERRDIS

ADRADD:					;ANWENDER-PC ERHOEHEN
		LD HL,(USERPC)
		INC HL
		LD (USERPC),HL
		CALL MEMDP2		;ANZEIGEN
		RET

TPFUN1:					;BEI "TO TAPE" NAECHSTER PARAMETER
		LD HL,ATFLAG
		INC (HL)		;FLAS AUF NEUEN PARAMETER
		CALL LOCTNA		;PARMETER 'F','S' ODER 'E'
		JR NZ,ISTEP		;SPRUNG, WENN RICHTIG
		DEC (HL)		;FLAG AUF ALTEN WERT
		JP ERRDIS		;FEHLERANZEIGE
ISTEP:
		CALL STEPDP		;PARAMETER ANZEIGEN
		RET

;--------------------- UNTEREINTRITT "-"-TASTE -----
;			(UEBER DTAB)
DFIX:					;BEDIENUNGSFEHLER
		JP ERRDIS

ADRDEC:					;ANWENDER-PC ERNIEDRIGEN
		LD HL,(USERPC)
		DEC HL
		LD (USERPC),HL
		CALL MEMDP2		;ANZEIGEN
		RET

TPTUN2:					;BEI "TO TAPE" VORHERIGER PARAMETER
		LD HL,ATFLAG
		DEC (HL)		;FLAG AUF VORHER. PARAMETER
		CALL LOCTNA		;PARAMETER 'F', 'S' ODER 'E'
		JR NZ,DSTEP		;SPR., WENN RICHTIG
		INC (HL)		;ALTER FLAGWERT
		JP ERRDIS		;FEHLERANZEIGE
DSTEP:
		CALL STEPDP		;PARAMETER ANZEIGEN
		RET

;--------------------- UNTEREINTRITT "EXEC"-TASTE ---
;			(UEBER ETAB)
EFIX:					;BEDIENUNGSFEHLER
		JP ERRDIS

ADREXC:					;PROGRAMAUSFUEHRUNG AB USER-PC
		PUSH HL
		LD HL,(USERPC)
		EX (SP),HL
		RET

ENDFUN:					; DE IN USER-PC ABSP. UND ANZEIGEN
		LD (USERPC),DE
		CALL MEMDP2
		RET

EWT:					;UEBERSPIELEN AUF BAND
		CALL SUM		;PRUEFSUMME BERECHNEN
		JR C,EFIX		;WENN ENDADR<ANF.ADR
		LD (CHKSUMH),A		;ABSPEICHERN
		LD HL,0FA0H		;AUSGABE 4000 x 1KHZ-TAKTE (4sek 1kHz)
					;ALS START-SYNC SIGNAL
		CALL SOUN1K
		LD HL,FILNAME		;DESCRIPTOR UEBERTRAGEN
		LD BC,0007H		;7 BYTE
		CALL TAPOUT
		LD HL,0FA0H		;AUSGABE 4000 x 2KHZ-TAKTE (2sek 2kHz)
					;ALS MITTEL-SYNC SIGNAL
		CALL SOUN2K
		CALL GETPTR		;LAENGE DES BLOCKES BER.
		CALL TAPOUT		;DATE UEBERTRAGEN
		LD HL,0FA0H		;AUSGABE 4000 x 2KHZ-TAKTE (2sek 2kHz)
					;ALS END SYNC. SIGNAL
		CALL SOUN2K
ENDTAP:
		LD DE,(ENDADRH)		;STARTADR
		JR ENDFUN		;ABSP. UND ANZEIGEN

;----------------- FEHLERTEXT LADEN, SPR. Z. ANZEIGE -
ERROR:
		LD IX,ERR		;ADR FEHLERTEXT
		JP SETSTO		;SPR. ZUR ANZEIGE

;----------------- DATEN VOM BAND LESEN --------
LOAD:
		LD HL,(FILNAME)
		LD (FILE2),HL
		LD A,0EFH		;DEZIMALPUNKTE EIN
		LD (TAPDIS),A
LEAD:
		LD A,(TAPDIS)
		OUT (SEGMENT),A
		LD HL,1000
LEAD1:
		CALL PERIOD		;EMPANGSFREQUENZ FESTSTELLEN
		JR C,LEAD		;WDHLG., SOLANGE NICHT 1 KHZ
		DEC HL			;TEST, OB 1000 MAL 1 KHZ
		LD A,H
		OR L
		JR NZ,LEAD1		;WDHLG., BIS 1000 x 1 KHZ
LEAD2:
		CALL PERIOD
		JR NC,LEAD2		;WDHLG., SOLANGE NOCH 1 KHZ
		LD HL,FILNAME		;ADR FUER HINTERLEGUNG DESCRIPTOR
		LD BC,0007H
		CALL TAPEIN		;7 BYTE LESEN
		JR C,LEAD		;SPR., WENN UEBERTRAGUNGSFEHLER
		LD DE,(FILNAME)
		CALL ADRSDP		;EMPFANGENEN FILENAMEN DARSTELLEN
		LD B,75
FILEDP:
		CALL DAK2		;ANZEIGEN
		DJNZ FILEDP
		LD HL,(FILE2)		;SOLL-NAMEN LESEN
		OR A
		SBC HL,DE
		LD A,0F7H		;"-"-ZEICHEN
		LD (TAPDIS),A
		JR NZ,LEAD		;SPR., WENN FALSCHER FILENAME
		LD A,0FEH		; "'"-ZEICHEN EIN
		OUT (SEGMENT),A
		CALL GETPTR		;LAENGE DES BLOCKES BER.
		JR C,ERROR		;WENN ENDADR<ANF.ADR
		CALL TAPEIN		;DATENSATZ EINLESEN
		JR C,ERROR		;SPR., WENN UEBERTR.FEHLER
		CALL SUM		;PRUEFSUMME BER.
		LD HL,CHKSUMH
		CP (HL)			;VERGLEICH MIT UEBERTR. PRUEFS.
		JR NZ,ERROR		;SPR., WENN FEHLER
		JR ENDTAP

;----------------- FUNKTIONSTASTEN AUSWERTEN -------
BRANCH:
		LD E,(HL)		;ADR DES FUNKTIONSPROGRAMMTEILS
		INC HL
		LD D,(HL)
		INC HL
		PUSH DE			;DE=Adr.
		LD E,A			;A=Index
		LD D,0
		ADD HL,DE
		POP DE
		LD L,(HL)		;L=Byte an Index-Pos.
		LD H,0
		ADD HL,DE		;ADR DES GEW. PROG. TEILS
		JP (HL)

;----------------- -
ERRDIS:
		LD HL,FUFEFLAG		;FUNKTIONS- UND FEHLERFLAG
		SET 7,(HL)		;setze Fehlerbit
		RET

;----------------- MUSIK UND GRAPHIK BEI ERSTEINSCH. -
INI:
		LD A,80H
		LD (INIFLAG),A		;FLAG AUF INITIALISIERT SETZEN
		CALL MONMUS		; MUSIKPROGRAMM
		CALL INIDIP		; ANFANGSGRAPHIK
		RET

;-----------------------------------------------------
; zu HDA: ein Byte lschen, wenn kein Fehler vorliegt
PRECL1:
		LD A,(FUFEFLAG)
		OR A
		RET Z			;RET., WENN KEIN FLAG
		LD A,0
		LD (HL),A		;ZELLE LOESCHEN
		LD (FUFEFLAG),A		;FLAG LOESCHEN
		RET

;---------------------- 2 BYTE IM RAM LOESCHEN ------
; zu HAD und HTAPWR: zwei Byte lschen, wenn kein Fehler vorliegt
PRECL2:
		CALL PRECL1		;1 BYTE LOE., WENN FUFEFLAG NICHT 0
		RET Z			;RET., WENN KEIN FLAG
		INC HL
		LD (HL),A		;NAECHSTE ZELLE LOESCHEN
		DEC HL
		RET

;--------------------- ADR U. DAT ANZ., ADR GEPUNKTET-
MEMDP1:
		LD A,01H		;CODE "ADRESSE"
		LD B,04H		;ANZ. ADRESSSTELLEN
		LD HL,ADRLED
		JR SAV12

;--------------------- ADR U. DAT ANZ.,ADR GEPUNKTET -
MEMDP2:
		LD A,02H		;CODE "DATEN"
		LD B,02H		;ANZAHL DATENSTELLEN
		LD HL,DATLED
SAV12:
		LD (ATCODE),A		;CODE ABSPEICHERN
		EXX
		LD DE,(USERPC)		;ANWENDERADR ANZEIGEN
		CALL ADRSDP
		LD A,(DE)		;INHALT DER ADRESS. RAM-ZELLE
		CALL DADP		;DATUM ANZEIGEN
		EXX
SETPT:
		SET 4,(HL)		; DEZIMALPUNKTE SETZEN
		INC HL
		DJNZ SETPT		;WDHLG., BIS ALLE DEZIMALPUNKTEPT
		RET

;--------------------- PARAMETER ANZEIGEN ----------
STEPDP:
		CALL LOCTBF		;PARAMETERADR. BERECHNEN
		LD E,(HL)		;INHALT DER ADRES. ZELLE NACH DE
		INC HL
		LD D,(HL)
		CALL ADRSDP		;DARSTELLEN
		LD HL,ADRLED		;ADR PUNKTIEREN
		LD B,04H
		CALL SETPT
		CALL LOCTNA		;ZEICHEN FUER PARAMETERANZ. NACH A
		LD L,A
		LD H,08H		;"-"-ZEICHEN
		LD (DATLED),HL		;IN DATENANZ. DARSTELLEN
		RET

;--------------------- PARAMETERADR. BERECHNEN ----
;			EINTTRIT: ----
;			AUSTRITT: ADR IN HL
;			ZERSTOERT: A
LOCTBF:
		LD A, (ATFLAG)		;PARAMETERCODE
		ADD A,A			; x 2
		LD HL,FILNAME
		ADD A,L			; + DESCRIPTOR-AREA
		LD L,A
		RET

;--------------------- ZEICHEN FUER PARAMETERANZEIGE --
			;EINTRITT:
			;AUSTRITT: ZEICHEN IN A
			;ZERSTOERT: DE
LOCTNA:
		LD A,(ATCODE)		; CODE "FROM TAPE" ODER "TO TAPE"
		SUB 04H			; - 4
		ADD A,A
		ADD A,A			; x 4
		LD DE,DISP4		; ANZEIGETEXT Parameter-Buchstaben
		ADD A,E
		LD E,A			;NEUE ADR NACH DE (FROM ODER TO)
		LD A,(ATFLAG)		;CODE FUER PARAMETER
		ADD A,E
		LD E,A			;ADRESSE ZEICHEN
		LD A,(DE)
		OR A
		RET

;--------------------- GRAPHIK FUER ANFANGS-ANZEIGE --
INIDIP:
		LD C,05H		;ANZAHL DER WDHLG.
		LD HL,DISP3		;TEXT "HALLO "
		PUSH HL
		LD IX,DISP2		;TEXT " USER "
A1:
		CALL SOU1K
		EX (SP),IX		;ADRESS-AUSTAUSCH
		LD B,20			;0.2 Sek
A2:
		CALL DAK2
		DJNZ A2
		CALL SOU2K
		LD B,20			;0.2 Sek
A3:
		CALL DAK2
		DJNZ A3
		DEC C
		JR NZ,A1

		LD C,21			; 21 Schritte Laufschrift (disp4-disp1)
		LD IX,DISP4		; leere Anzeige
BLOOP:
		LD B,11			;0.11 Sek
B1:
		CALL DAK2
		DJNZ B1
		BIT 0,C			; in jedem Schleifendurchlauf
		JR NZ,B2		; Wechsel zw. sou1k und sou2k
		CALL SOU2K
		JR B3
B2:
		CALL SOU1K
B3:
		DEC IX			; Laufschrift nchster Schritt
		DEC C
		JR NZ,BLOOP

		POP HL			;STACK-KOR.
		RET

;---------------------- 1KHZ80ms ----------------
SOU1K:
		EXX
		LD HL,80
		CALL SOUN1K
		EXX
		RET

;--------------------- 2KHZ80ms -----------------
SOU2K:
		EXX
		LD HL,160
		CALL SOUN2K
		EXX
		RET

;--------------------- TONSIGNAL 1KHZ --------------

; FUNKTION: Ausgabe eines Tonsignals von 1 kHz
; EINTRITT: Der Inhalt der Register HL gibt die Anzahl der Takte an; Hchstwert 32768 Takte.
; AUSTRITT: ---
; REGISTER: Die Inhalte der Register Arg BC, DE, HL, werden zerstrt.

SOUN1K:
		LD C,32
		JR SOUND

;--------------------- TONSIGNAL 2KHZ --------------

; FUNKTION: Ausgabe eines Tonsignals in 2 kHz
; EINTRITT: Der Inhalt der Register HL gibt die Anzahl der Takte an; Hchstwert 32768 Takte
; AUSTRITT: ---
; REGISTER: Die Inhalte der Register AF, BC, DE, HL werden zerstrt.

SOUN2K:
		LD C,15

; FUNKTION: Tonsignal fr Lautsprecher
; EINTRITT: Der Inhalt des Registers C gibt die Tonfrequenz an.
; Der Inhalt der Register HL gibt die Anzahl der Takte an, Hchstwert 32768 Takte
; AUSTRITT: ---
; REGISTER: Die Inhalte der Register AF, B, DE, HL, werden zerstrt.

SOUND:
		ADD HL,HL		; x 2 WEGEN H- UND L-TEIL DES TAKTES
		LD DE,0001H		;FUER ZAEHLUNG
		LD A,0FFH		;TAPE.OUT=H, ANZEIGE AUS
SQWAVE:
		OUT (DIGITAP),A
		LD B,C
		DJNZ $			;ZEITVERZ.
		XOR 2			;TAPE.OUT=L
		SBC HL,DE
		JR NZ,SQWAVE		;WDHLG., BIS ALLE TAKTE
		RET

;--------------------- PRUEFSUMME ----------------
			;EINTRITT: -
			;AUSTRITT: SUMME IN A
SUM:
		CALL GETPTR
		RET C			;RET., WENN FEHLER
		XOR A
SUMCAL:
		ADD A,(HL)		;AUFSUMMIEREN
		CPI			;NAECHSTE ADR
		JP PE,SUMCAL		;WDHLG., BIS ALLE BYTES
		OR A
		RET

;--------------------- SPEICHERLAENGE BER. ---------
			;EINTRITT:
			;AUSTRITT: LAENGE IN BC
			;	BEI FEHLER CY=1
GETPTR:
		LD HL,STARTADR		;DESCRIPTORAREA
		LD E,(HL)		;STARTADR
		INC HL
		LD D,(HL)
		INC HL
		LD C,(HL)		;ENDADR (C ZWI.SP. WEG. ADR IN HL)
		INC HL
		LD H,(HL)
		LD L,C
		OR A			;CY LOESCHEN
		SBC HL, DE		;ABSTAND
		LD C,L			;NACH BC LADEN
		LD B,H
		EX DE,HL
		RET

;---------------------- LESEN VOM BAND -------------
			;EINTRITT: ZIELANFANGSADR IN HL
			;	LAENGE IN BC
			;AUSTRITT:
 TAPEIN:
		XOR A
		EX AF,AF'		;'
 TLOOP:
		CALL GTBYTE		;1 BYTE LESEN
		LD (HL),E		;ABSPEICHERN
		CPI			;NAECHSTE ADR
		JP PE,TLOOP		;WDHLG., BIS ALLE BYTE
		EX AF,AF'		;'
		RET

;-------------------- 1 BYTE VOM BAND LESEN ----
			;EINTRITT:
			;AUSTRITT: DATENBYTE IN E
 GTBYTE:
		CALL GETBIT		;STARTBIT
		LD D,08H		;8 BIT
 GLOOP:
		CALL GETBIT		;DATENBIT LESEN
		RR E			;IN E SCHIEBEN
		DEC D
		JR NZ,GLOOP		;WDHLG., BIS 8 BIT
		CALL GETBIT		;STOPBIT
		RET

;-------------------- 1 BIT VOM BAND LESEN ---------
			;EINTRITT:
			;AUSTRITT: BIT IN CY
GETBIT:
		EXX
		LD HL,0000
COUNT:
		CALL PERIOD		;TAKTLAENGE
		INC D
		DEC D			;Z-FLAG SETZEN/RUECKSETZEN
		JR NZ,TERR		;SPR., WENN ZU GROSS (FEHLER)
		JR C,SHORTP		;SPR., WENN 1 KHZ
					;FREQU. IST 2 KHZ
		DEC L			;L=L-2
		DEC L
		SET 0,H			;H=1
		JR COUNT		;WDHLG.
SHORTP:
					;FREQU. IST 1 KHZ
		INC L			;L=L+1
		BIT 0,H
		JR Z,COUNT		;SPR., WENN NOCH NICHT 2 KHZ EMPFANGEN
		RL L			;BIT IN CY
		EXX
		RET
TERR:
					;FREQUENZ AUSSER ERLAUBTEM BEREICH
		EX AF,AF'		;'
		SCF
		EX AF,AF'		;'
		EXX
		RET

;--------------------- ADR 2. ROM/EPROM --------------
		ORG 0400H

		IF ROM_=2
		DEFB 0FFH
		ORG 0800H
		ENDIF

;--------------------- TAKTLAENGE VOM BAND-SIGNAL ----
			;EINTRITT: ----
			;AUSTRITT: CY=O --> 1 KHZ
			;	CY=1 --> 2 KHZ
PERIOD:
		LD DE,0000		;ZAEHLER = 0
CHK0:
		IN A,(DIGITAP)		;EINLESEN
		INC DE			;ZAEHLER ERHOEHEN
		RRA
		JR C,CHK0		;WDHLG., WENN EINGANG H
		LD A,0			;AZEIGE FREI, TAPE.OUT = L
		OUT (DIGITAP),A
CHK1:
		IN A,(DIGITAP)		;EINLESEN
		INC DE			;ZAEHLER ERHOEHEN
		RRA
		JR NC,CHK1		;WDHLG., WENN EINGANG L
		LD A,2			; ANZEIGE FREI, TAPE.OUT = H
		OUT (DIGITAP),A
		LD A,E
		CP 22			;TEST	<> 1,5 KHZ
		RET

;--------------------- DATEN AUF BAND AUSGEBEN ------
			;EINTRITT: ANFANGSADR. IN HL
			;	ANZAHL IN BC
			;AUSTRITT:
TAPOUT:
		LD E,(HL)		;BYTE NACH E
		CALL OUTBYTE
		CPI			;NAECHSTES BYTE
		JP PE,TAPOUT		;WDHLG., WENN NOCH BYTES ZU SENDEN
		RET

;--------------------- EIN BYTE AUSGEBEN ----------
			;EINTRITT: BYTE IN E
			;AUSTRITT:
OUTBYTE:
		LD D,08H		;8 BIT
		OR A
		CALL OUTBIT		;STARTBIT
OLOOP:
		RR E			;BIT IN CY
		CALL OUTBIT		;DATENBIT AUSGEBEN
		DEC D
		JR NZ,OLOOP		;WDHLG., BIS 8 BIT
		SCF
		CALL OUTBIT		;STOPBIT
		RET

;----------------- -
OUTBIT:
		EXX			;OUTPUT 1 BIT DATA
		LD H,0
		JR C,OUT1
OUT0:
		LD L,0CH		;6ms 2K
		CALL SOUN2K
		LD L,03H		;3ms 1k	
		JR BITEND
OUT1:
		LD L,06H		;3ms 2K
		CALL SOUN2K
		LD L,06H		;6ms 1k
BITEND:
		CALL SOUN1K
		EXX
		RET
;---------------------- TEST, OB (HL) RAM IST -------
;			2 x INVERTIERTES SCHREIBEN UND
;			LESEN AUS/IN DEN DURCH HL ANGEG.
;			SPEICHERPLATZ UND VERGLEICHEN
;			AUSGABE: Z=1, WENN RAM

; FUNKTION: Test ob ein Speicherplatz im RAM liegt
; EINTRITT: HL gibt den Speicherplatz an.
; AUSTRITT: Z-Flag = 1 wenn (HL) RAM ist.
; REGISTER: Der Inhalt der Register AF wird zerstrt.

RAMCHK:
		LD A,(HL)
		CPL
		LD (HL),A
		LD A,(HL)
		CPL
		LD (HL),A
		CP (HL)
		RET

;--------------------- LED UND TASTATUR-ABFR.--------
; wie DAK2, aber:
; - die Funktion wird fortgesetzt, bis eine Taste gedrckt wurde.
; - Anstelle des Tastencodes wird der umgewandelte interne Code geliefert,
; wie er von anderen Teilen des Monitorprogrammes bentigt wird.
; EINTRITT: IX zeigt auf die niederwertigste Adresse des Speicherbereiches,
; 	der zur Anzeige gelangen soll.
; AUSTRITT: Der interne Code befindet sich im ARegister.
; REGISTER: Die Inhalte von AF, B, HL, A'F', B'C', D'E' werden zerstrt.

; Taste interner Code

; 0..F	00..0F
; +	10
; -	11
; EX	12
; DAT	14
; ADR	19
; ST	1E
; LD	1F

DAK1:
		PUSH IX			;ADR ANZ.TEXT RETTEN
		LD HL,FUFEFLAG
		BIT 7,(HL)		;FEHLERFLAG TESTEN
		JR Z,SCPRE		;SPR., WENN KEIN FEHLER
		LD IX,ERR		;ADR FEHLERTEXT
SCPRE:
		LD B,06H
SCNX:
		CALL DAK2
		JR NC,SCPRE		;WDHLG., WENN TASTE NOCH GEDR.
		DJNZ SCNX
		RES 7,(HL)		;FEHLERLAG LOESCHEN
		POP IX			;ALTER TEXT
SCLOOP:
		CALL DAK2
		JR C,SCLOOP		;WDHLG., WENN KEINE TASTE GEDR.
		LD HL,KEYTAB		;TASTE NACH TABELLE UMCODIEREN
		ADD A,L
		LD L,A
		JR NC,SCNCY
		INC H
SCNCY:
		LD A,(HL)		;UMCODIERTER TASTENWERT
		RET

;----------------- LED U. TASTATUR-UP --------------
; Einmalige Ansteuerung von Anzeige und Tastatur, alle 6 LED-Anzeigen werden
; nacheinander angesteuert ( Ausfhrungszeit ca. 10 ms).
; Eintritt: IX, zeigt auf die niederwertigste Adresse des Speicherbereiches,
; 	der zur Anzeige gelangen soll.
; Austritt: CY = 1, wenn keine Taste gedrckt
; 	CY = 0, wenn eine Taste gedrckt (auer RES oder NMI).
; 	Der Positionscode der Taste befindet sich im A-Register.
; Register: Die Inhalte von AF, A' F', B' C', D'E' werden zerstrt.


; TASTATURMATRIX
;
; System-PIO, DIGITAP
;
;   B2    B3    B4    B5    B6    B7
;   |     |     |     |     |     |
; +-----+-----+-----+-----+-----+-----+
; | EX  | 0   | 4   | 8   | C   | ADR |  --> B7 User-IO, KEYIN
; | 00  | 04  | 08  | 0C  | 10  | 14  |  --  Tastencode DAK2
; +-----+-----+-----+-----+-----+-----+
; | ST  | 1   | 5   | 9   | D   | DAT |  --> B6
; | 01  | 05  | 09  | 0D  | 11  | 15  |
; +-----+-----+-----+-----+-----+-----+
; | LD  | 2   | +   | E   | A   | 6   |  --> B5
; | 02  | 06  | 0A  | 0E  | 12  | 16  |
; +-----+-----+-----+-----+-----+-----+
; |     | 3   | 7   | B   | F   | -   |	 --> B4
; |     | 07  | 0B  | 0F  | 13  | 17  |
; +-----+-----+-----+-----+-----+-----+

DAK2:
		SCF			;keine Taste gedrckt setzen
		EX AF,AF'		;' und als Vorgabe merken
		EXX
		LD C,0			;TASTENNUMMER = 0
		LD E,11111011B		;BITMUSTER FUER DIGITANSTEUERUNG
					;Bit2 = 0 -> erste Spalte low
KCOL:
		LD A,(IX)		;SEGMENTE ANSTEUERN
		CPL
		OUT (SEGMENT),A
		LD A,E			;DIGIT ANSTEUERN
		OUT (DIGITAP),A
		LD B,100		;ZEITVERZOEGERUNG
		DJNZ $
		LD B,04H		;ZEILENZAHL TASTENMATRIX
		IN A,(KEYIN)		;TASTENWERT EINLESEN
		LD D,A			;TEST, OB TASTE GEDRUECKT
KROW:
		RL D			;Bit7 -> Cy, restl. Bit rcken nach
		JR C,NOKEY		;wenn Taste nicht gedrckt
		LD A,C			;wenn Taste gedrckt, ist C der Tastencode
		EX AF,AF'		;' Taste merken
		;WENN TASTE: -> CY=0, A = NUMMER
NOKEY:
		INC C			;ABFRAGEZAEHLER ERHOEHEN
		DJNZ KROW		;WDHLG., WENN NOCH NICHT ALLE ZEILEN
		INC IX			;NAECHSTES ZEICHEN ZUR ANZEIGE
		RLC E			;nchste Spalte low
		LD A,0FFH
		OUT (DIGITAP),A		;ANZEIGE AUS
		JR C,KCOL		;GGF. NAECHSTE SPALTE
		LD DE,0FFFAH		; -6
		ADD IX,DE		;WIEDERHERST. ANF.ADR DES ANZ.TEXTES
		EXX
		EX AF,AF'		;' gemerkte Taste nach A
		RET

;-------------------- ADRESSE ANZEIGEN -------------
; FUNKTION: Eintragen von 4 Ziffern in den Adressanzeigespeicher
; 	(Adressen 23F4 - 23F7H)
; EINTRITT: Anzuzeigende Zahl in DE
; AUSTRITT: Entsprechender 7-Segment-Code im Adressanzeigespeicher
; REGISTER: Die Inhalte der Register AF und HL werden zerstrt.

ADRSDP:
		LD HL,ADRLED
		LD A,E			;UNTERE 2 ZIFFERN
		CALL TWOSEG
		LD A,D			;OBERE 2 ZIFFERN
		CALL TWOSEG
		RET

;---------------------- A-REG IN DAT-ANZ-SPEICHER ---
; FUNKTION: Eintragen von 2 Ziffern in den Datenanzeigespeicher
; 	(Adressen 23F2 - 23F3H)
; EINTRITT: Anzuzeigende Zahl in A
; AUSTRITT: Entsprechender 7-Segment-Code im Datenanzeigespeicher
; REGISTER: Die Inhalte der Register AF und HL werden zerstrt.
DADP:
		LD HL,DATLED
		CALL TWOSEG
		RET

;--------------------- -
; FUNKTION: Umwandeln einer Ziffer in den entsprechenden 7-Segment-Code
; EINTRITT: Die rechten 4 Bit des A-Registers sind die umzuwandelnde Hex-Zahl.
; AUSTRITT: Der entsprechende 7-Segment-Code steht im A-Register.
; REGISTER: Der Inhalt in AF wird zerstrt

ONESEG:
		PUSH HL
		PUSH DE
		LD HL,SEGTAB		;ADR DER SEGMENTTABELLE
		AND 0FH			;OBERES HALBBYTE AUSBLENDEN
		LD E,A
		LD D,0
		ADD HL,DE
		POP DE
		LD A,(HL)		;KONVERTIERTE ZAHL NACH A
		POP HL
		RET

;--------------------- -
; FUNKTION: Umwandeln des Inhalts des A-Registers in die zugehrigen 2 7-Segment-Codes.
; EINTRITT: Untere Tetrade von A als 1.Ziffer Obere Tetrade von A als 2.Ziffer
; AUSTRITT: Der erste Code wird in (HL), der zweite Code in (HL + 1) abgespeichert.
; 	HL wird um 2 erhht.
; REGISTER: Die Inhalte der Register AF und HL werden zerstrt.

TWOSEG:
		PUSH AF
		CALL ONESEG		;UNTERE ZIFFER UMWANDELN
		LD (HL),A		;ABSPEICHERN
		INC HL			;ADR FUER HINTERLEGUNG OBERE ZAHL
		POP AF			;URSPRUENGL. ZAHL
		RRCA
		RRCA
		RRCA
		RRCA			;OBERES HALBBYTE
		CALL ONESEG		;OBERE ZIFFER UMWANDELN
		LD (HL),A		;ABSPEICHERN
		INC HL			;ADR GGF. NAECHSTE ZIFFER
		RET

;--------------------- MUSIKPROGRAMM -----------------

; FUNKTION: Spielen der Anfangsmusik
; EINTRITT: ---
; AUSTRITT: ---
; REGISTER: Die Inhalte der Register IX, IY, AF, DC, DE, HL werden zerstrt.

MONMUS:
		LD IY,SONG		;ADR DER NOTEN

; FUNKTION: Spielen von Musik
; EINTRITT: Im Register IY steht die Startadresse des Musikstckes
; AUSTRITT: ---
; REGISTER: Die Inhalte der Register IX, AF, BC, DE, HL werden zerstrt.

; Jeweils 2 Byte reprsentieren eine Note.
; Das erste Byte gibt die Tonhhe, das zweite Byte die Tonlnge an.
; Hat das erste Byte den Wert 80H, wird das Musikprogramm
; verlassen, bei 40H wird das Programm von vorn begonnen, bei 20H
; wird eine Pause mit der durch das zweite Byte angegebenen Lnge
; gemacht.
; Als Werte fr die Tonhhe sind die Zahlen 0H bis 1FH erlaubt.
; Bezogen auf eine Taktfrequenz von 900 kHz entsprechen
; aufeinanderfolgende Zahlen jeweils einen Halbtonschritt, wobei der
; tiefste Ton (00H) etwa dem Ton cis entspricht.
; Die Tonlnge ist frei whlbar.

MUSIC:
		PUSH IY
		POP IX
MUSLOOP:
		LD A,(IX)		;tonhhe/befehl
		ADD A,A
		RET C			;WENN WERT >= 80H Ende
		JP M,MUSIC		;WENN WERT >= 40H wiederholen
		LD C,0			;vorbelegen mit Pause
		BIT 6,A
		JR NZ,PLAY		;WENN WERT >= 20H Pause
		SET 1,C			;AUSGABE-BIT (C:=2)
PLAY:
		AND 3FH			; A ist schon tonhhe*2
		LD HL,FRQTAB		; Frequenztabelle
		LD E,A			; Tonhhe
		LD D,0
		ADD HL,DE		; + 2x Tonhhe
		LD E,(HL)		; erster Frequenzwert
		INC HL
		LD D,(HL)		; zweiter Freq.wert
		INC IX			;Tonlnge
		LD H,(IX)		;merken
		LD A,0FFH
TONE:
		LD L,D			; zweiter Freq.wert
TONOUT:
		OUT (DIGITAP),A
		LD B,E			; erster Freq.wert
DELAY:					; Verzgerungsschleife
		NOP
		DJNZ DELAY
		XOR C			; Toggle Bit f. PIO
					; bei PAUSE erfolgt keine nderung des Bits!
		DEC L
		JR NZ,TONOUT		; weiter in Schleife
		DEC H			; Tonlnge
		JR NZ,TONE		; weiter in Tonausgabe
		INC IX			; Pointer auf nchste Note
		JR MUSLOOP

;--------------------- ANZEIGEMOD TESTEN -------------
TESTM:
		LD A,(ATCODE)
		CP 01H			; ADRS
		RET Z
		CP 02H			; DATS
		RET Z
		POP HL			;RUECKKEHRADR. LOESCHEN
		JP ERRDIS

;--------------------- FREQUENZTABELLE ---------------
; erster Wert f. Tonhhe, zweiter Wert f. konstante Tonlnge
; erster ton laut Handbuch Ais
; Tne nachgerechnet, stimmt ! -> tne lc-80.xlsx
; (laut Zielosko beginnt die Tabelle mit Cis. Das ist falsch! )
FRQTAB:
		DEFB 70H, 18h		; 00 Ais
		DEFB 6AH, 1Ah		; 01 H
		DEFB 64H, 1Bh		; 02 C'
		DEFB 5EH, 1Dh		; 03 Cis
		DEFB 59H, 1Eh		; 04 D
		DEFB 54H, 20h		; 05 Dis
		DEFB 4FH, 22h		; 06 E
		DEFB 4BH, 24h		; 07 F
		DEFB 46H, 26h		; 08 Fis
		DEFB 42H, 29h		; 09 G
		DEFB 3FH, 2Bh		; 0A Gis
		DEFB 3BH, 2Eh		; 0B A
		DEFB 38H, 31h		; 0C Ais
		DEFB 35H, 33h		; 0D H
		DEFB 32H, 37h		; 0E C'
		DEFB 2FH, 3Ah		; 0F Cis'
		DEFB 2CH, 3Dh		; 10 D'
		DEFB 2AH, 41h		; 11 Dis'
		DEFB 27H, 45h		; 12 E'
		DEFB 25H, 49h		; 13 F'
		DEFB 23H, 4Dh		; 14 Fis'
		DEFB 21H, 52h		; 15 G'
		DEFB 1FH, 57h		; 16 Gis'
		DEFB 1DH, 5Ch		; 17 A'
		DEFB 1BH, 62h		; 18 Ais'
		DEFB 1AH, 67h		; 19 H'
		DEFB 18H, 6Eh		; 1A C''
		DEFB 17H, 74h		; 1B Cis''
		DEFB 16H, 7Bh		; 1C D''
		DEFB 14H, 82h		; 1D Dis''
		DEFB 13H, 8Ah		; 1E E''
		DEFB 12H, 92h		; 1F F''

;---------------------- TEXTE ------------------------
DISP1:				; "OF LC-80"
		DEFB 0E7H		;"0"
		DEFB 0EFH		;"8"
		DEFB 08H		;""
		DEFB 0C6H		;"C"
		DEFB 0C2H		;"L"
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 4EH		;"F"
		DEFB 0E7H		;"O"
DISP2:				; " USER "
		DEFB 00H		;" "
		DEFB 048H		;"R"
		DEFB 0CEH		;"E"
		DEFB 0AEH		;"S"
		DEFB 0E3H		;"U"
		DEFB 000H		;" "
DISP3:				; " HALLO "
		DEFB 000H		;" "
		DEFB 0E7H		;"O"
		DEFB 0C2H		;"L"
		DEFB 0C2H		;"L"
		DEFB 06FH		;"A"
		DEFB 06BH		;"H"
DISP4:				;Parameter-Buchstaben (ATCODE-4)
				;gleichzeitig leere Anzeige
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 00H		;" "
				;
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 00H		;" "
		                ;TO TAPE
		DEFB 04EH		;"F"	filename
		DEFB 0AEH		;"S"	startadr
		DEFB 0CEH		;"E"	endadr
		DEFB 00H		;" "
				;FROM TAPE
		DEFB 04EH		;"F"	filename
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 00H		;" "
DISP5:				; " int "
		DEFB 00H		;" "
		DEFB 00H		;" "
		DEFB 0CAH		;"t"
		DEFB 68H		;"n"
		DEFB 21H		;"i"
		DEFB 00H		;" "
DISP6:				; "rst 38"
		DEFB 0EFH		;"8"
		DEFB 0ADH		;"3"
		DEFB 00H		;" "
		DEFB 0CAH		;"t"
		DEFB 0AEH		;"s"
		DEFB 48H		;"r"
ERR:				; "error"
		DEFB 00H		;" "
		DEFB 48H		;"r"
		DEFB 0E8H		;"o"
		DEFB 48H		;"r"
		DEFB 48H		;"r"
		DEFB 0CEH		;"E"

;--------------------- -
; KEYEXC Funktionstastentabelle
; Aufbau: 2 Byte Adresse, dann Tabelle mit Byte-Offsets
; je nach idx wird Adr+Byte-Offs berechnet und dann diese Routine angesprungen
; das spart vermutlich ein paar Byte gegenber einer direkten case-anweisung
; aber: die zu rufenden Routinen msen innerhalb von 255 Byte nach der Basis-Routine liegen

; Funktionsgruppe 1 "+","-","EXEC" O. "DATA"
KSUFUN:
		DEFW KINC
		DEFB KINC-KINC		;0 10 "+" 	--> Sprung nach KINC
		DEFB KDEC-KINC		;1 11 "-"	--> Sprung nach KDEC
		DEFB KEXEC-KINC		;2 12 "EXEC"	--> usw.
		DEFB 00H                ;3
		DEFB KDATA-KINC		;4 14 "DATA"
		DEFB 00H                ;5
		DEFB 00H                ;6
		DEFB 00H                ;7
;--------------------- -
; Funktionsgruppe 2 ADR- ODER TAPE-TASTEN
KFUN:
		DEFW KADRS
		DEFB 00H                ;0 18
		DEFB KADRS-KADRS	;1 19 ADR "ADRS"
		DEFB 00H                ;2 1A
		DEFB 00H                ;3 1B
		DEFB 00H                ;4 1C
		DEFB 00H                ;5 1D
		DEFB KTAPWR-KADRS	;6 1E ST  "TO TAPE"
		DEFB KTAPWR-KADRS	;7 1F LD  "FROM TAPE*
;--------------------- -
; die folgenden Tabellen beziehen sich auf ATCODE
; 1-ADRS, 2-DATS, 6-TO TAPE, 7-FROM TAPE

; nach Zifferntaste (nach KHEX)
HTAB:
		DEFW HFIX
		DEFB HFIX-HFIX		;0 FEHLER
		DEFB HAD-HFIX		;1 "ADRS" 	ZIFFER ALS ADRESSE
		DEFB HDA-HFIX		;2 		ZIFFER ALS DATUM
		DEFB 00H                ;3
		DEFB 00H                ;4
		DEFB 00H                ;5
		DEFB HTAPWR-HFIX	;6 "TO TAPE"	ZIFFER ALS PARAMETER FUER BAND
		DEFB HTAPWR-HFIX	;7 "FROM TAPE"	ZIFFER ALS PARAMETER FUER BAND
		DEFB 00H		;8
		DEFB 00H		;9
;--------------------- -
; nach KINC ("+"-TASTE)
ITAB:
		DEFW IFIX
		DEFB IFIX-IFIX		;0 BEDIENUNGSFEHLER
		DEFB ADRADD-IFIX	;1 ANWENDER-PC ERHOEHEN
		DEFB ADRADD-IFIX	;2 ANWENDER-PC ERHOEHEN
		DEFB 00H                ;3
		DEFB 00H                ;4
		DEFB 00H                ;5
		DEFB TPFUN1-IFIX	;6 BEI "TO TAPE" NAECHSTER PARAMETER
		DEFB TPFUN1-IFIX	;7 BEI "TO TAPE" NAECHSTER PARAMETER
		DEFB 00H		;8
		DEFB 00H		;9
;--------------------- -
; nach KDEC ("-"-TASTE)
DTAB:
		DEFW DFIX
		DEFB 00H		;0 BEDIENUNGSFEHLER
		DEFB ADRDEC-DFIX	;1 ANWENDER-PC ERNIEDRIGEN
		DEFB ADRDEC-DFIX	;2 ANWENDER-PC ERNIEDRIGEN
		DEFB 00H                ;3
		DEFB 00H                ;4
		DEFB 00H                ;5
		DEFB TPTUN2-DFIX	;6 BEI "TO TAPE" VORHERIGER PARAMETER
		DEFB TPTUN2-DFIX	;7 BEI "TO TAPE" VORHERIGER PARAMETER
		DEFB 00H		;8
		DEFB 00H		;9
;--------------------- -
; nach KEXEC ("EXEC"-TASTE)
ETAB:
		DEFW EFIX
		DEFB 00H		;0 BEDIENUNGSFEHLER
		DEFB ADREXC-EFIX	;1 PROGRAMAUSFUEHRUNG AB USER-PC
		DEFB ADREXC-EFIX	;2 PROGRAMAUSFUEHRUNG AB USER-PC
		DEFB 00H                ;3
		DEFB 00H                ;4
		DEFB 00H                ;5
		DEFB EWT-EFIX		;6 UEBERSPIELEN AUF BAND
		DEFB LOAD-EFIX		;7 DATEN VOM BAND LESEN
		DEFB 00H		;8
		DEFB 00H		;9
;----------------- TASTATURTABELLE -------------------
KEYTAB:
		DEFB 12H		; 00  EXECUTE
		DEFB 1EH		; 01  STORE
		DEFB 1FH		; 02  LOAD
		DEFB 0			; 03  NICHT BELEGT
		DEFB 0			; 04  0
		DEFB 1  		; 05  1
		DEFB 2  		; 06  2
		DEFB 3  		; 07  3
		DEFB 4  		; 08  4
		DEFB 5  		; 09  5
		DEFB 10H		; 0A  +
		DEFB 7  		; 0B  7
		DEFB 8  		; 0C  8
		DEFB 9  		; 0D  9
		DEFB 0EH		; 0E  A
		DEFB 0BH		; 0F  B
		DEFB 0CH		; 10  C
		DEFB 0DH		; 11  D
		DEFB 0AH		; 12  E
		DEFB 0FH		; 13  F
		DEFB 19H		; 14  ADRESS
		DEFB 14H		; 15  DATA
		DEFB 6  		; 16  6
		DEFB 11H		; 17  -

;----------------------- CODE FUER HEX-ZIFFERN --------
; Codierung in 7-Segement-Code
SEGTAB:
		DEFB 0E7H		; 0  "0"
		DEFB 21H		; 1  "1"
		DEFB 0CDH		; 2  "2"
		DEFB 0ADH		; 3  "3"
		DEFB 2BH		; 4  "4"
		DEFB 0AEH		; 5  "5"
		DEFB 0EEH		; 6  "6"
		DEFB 25H		; 7  "7"
		DEFB 0EFH		; 8  "8"
		DEFB 0AFH		; 9  "9"
		DEFB 6FH		; A  "A"
		DEFB 0EAH		; B  "B"
		DEFB 0C6H		; C  "C"
		DEFB 0E9H		; D  "D"
		DEFB 0CEH		; E  "E"
		DEFB 4EH		; F  "F"

;---------------------- LIED ------------------------
; Lied  "Popcorn" von Hot Butter
SONG:
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 10H, 02h		; D'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 0DH, 02h		; H
		DEFB 20H, 02h   	
		DEFB 09H, 02h		; G
		DEFB 20H, 02h   	
		DEFB 0DH, 02h		; H
		DEFB 20H, 02h   	
		DEFB 06H, 02h		; E
		DEFB 20H, 06h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 10H, 02h		; D'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 0DH, 02h		; H
		DEFB 20H, 02h   	
		DEFB 09H, 02h		; G
		DEFB 20H, 02h   	
		DEFB 0DH, 02h		; H
		DEFB 20H, 02h   	
		DEFB 06H, 02h		; E
		DEFB 20H, 06h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 14H, 02h		; Fis'
		DEFB 20H, 02h   	
		DEFB 15H, 02h		; G'
		DEFB 20H, 02h   	
		DEFB 14H, 02h		; Fis'
		DEFB 20H, 02h   	
		DEFB 15H, 02h		; G'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 14H, 02h		; Fis'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 14H, 02h		; Fis'
		DEFB 20H, 02h   	
		DEFB 10H, 02h		; D'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 10H, 02h		; D'
		DEFB 20H, 02h   	
		DEFB 12H, 02h		; E'
		DEFB 20H, 02h   	
		DEFB 0DH, 02h		; H
		DEFB 20H, 02h   	
		DEFB 12H, 04h		; E'
		DEFB 20H, 06h
		DEFB 80H
;-----------------------------------------------------

		IF ROM_=1
		ORG 0690H
		ENDIF

		IF ROM_=2
		ORG 0A90H
		ENDIF

; Registeranzeige
; zur Nutzung muss in 2340H JP START2 eingetragen werden 

START2:
		LD (REGHL),HL		; HL sichern
		LD HL,RETURN		; Ret-Funktion 
		LD (STEPZEI),HL		; festlegen
STARTST:
		POP HL			; aktuelle RET-Adr 
		PUSH HL			; == Unterbrechungs-Adr.
		LD (REGSP),SP		; SP sichern
		LD SP,ARBSTA		; Arbeitsstack
		CALL REGRET		; Register sichern
		LD A,(AREGST)		; A entspr. anzuzeigendes Register
					; nach Reset = FF -> 0 -> AF
		CPL
DEANZ1:
		LD IY,REGRAM		; gesicherte Register
DEANZ:					; (DEANZ wird nicht genutzt)
		PUSH AF			; Registernr
		LD HL,REGSYM		; Registernamen
		ADD A,L
		LD L,A
		LD E,(HL)		; 2. Zeichen
		INC HL
		LD D,(HL)		; 1. Zeichen
		LD (DATLED),DE		; in Anzeige eintragen
		POP AF
		LD D,0
		LD E,A
		ADD IY,DE
		LD E,(IY+0)		; lo Register
		LD D,(IY+1)		; hi Register
		LD (AREGIN),DE		; Wert merken f. Edit
		CPL
		LD (AREGST),A		; Register-Pointer merken
DATLOOP:
		CALL ADRSDP		; Wert eintragen
DAK:
		LD IX,DATLED
		CALL DAK1		; Anzeigen + Tastaturabfrage
		CP 10H			; 0..F
		JR C,HEXTAS
		JR Z, POSTAS		; +
		CP 11H			; -
		JR Z,NEGTAS
		CP 12H			; EX
		JR Z,EXTAS
		CP 19H			; ADR
		JR Z,ADRTAS
		CP 14H			; DAT
		JR Z,DATANZ
		JR DAK
HEXTAS:
		LD HL,AREGIN		; Ziffer in Registerwert
		RLD			; Tetraden in beiden Byte verschieben
		INC HL
		RLD
		LD DE,(AREGIN)		; Wert laden
		CALL ADRSDP		; in Anzeige eintragen
		LD HL,ADRLED
		LD B,4
		CALL SETPT		; als gendert markieren
		JR DAK			; und weiter editieren
; mit "EX" Wert in Register bernehmen
EXTAS:
		LD DE,(AREGIN)		; Wert
		LD (IY+0),E		; in Registerstack
		LD (IY+1),D		; ablegen
		JR DATLOOP
; "+" nchstes Register
POSTAS:
		LD A,(AREGST)		; Register-Pointer
		CPL
		CP 16H			; letztes Register erreicht?
		JR C,MPOS		; nein
		LD A,0FEH		; sonst -2 (wieder von vorn beginnen)
MPOS:
		INC A			; +2, Doppelregister weiter
		INC A
		JP DEANZ1
; "-" vorheriges Register
NEGTAS:
		LD A,(AREGST)		; Register-Pointer
		CPL
		CP 0			; erstes Register erreicht?
		JR NZ,MNEG		; nein
		LD A,18H		; sonst letztes + 2
MNEG:
		DEC A			; -2, Doppelregister zurck
		DEC A
		JP DEANZ1
; mit "ADR" Registeranzeige beenden 
ADRTAS:
		LD SP,ARBSTA		; SP auf REGRAM - 2 (wg. CALL)
		CALL REGLAD		; Register wiederherstellen
		LD SP,(REGSP)		; SP restaurieren
		POP HL			; orig. RET-Adr vom Stack
		LD HL,(REGPC)		; gesicherte aktuelle Adresse
		PUSH HL			; auf Stack
		LD HL,(STEPZEI)		; RETURN-Funktion
		JP (HL)			; anspringen
RETURN:
		LD HL,(REGHL)		; HL restaurieren
		RETN			; INT-Ende
; "DAT" Anzeige aktuelle Adresse und Wert (PC)
DATANZ:
		LD HL,(REGPC)		; aktuelle Adresse
		LD A,(HL)		; Bate an aktueller Adresse
		EX DE,HL
		CALL DADP		; anzeigen
		JP DATLOOP
REGRET:					; Register retten
		LD SP,AREGST
		PUSH HL			; REGPC, orig PC
		DEC SP			; REGSP, frei fr SP
		DEC SP
		PUSH IY
		PUSH IX
		EXX
		EX AF,AF'		;'
		PUSH HL
		PUSH DE
		PUSH BC
		PUSH AF
		EXX
		EX AF,AF'		;'
		DEC SP
		DEC SP
		PUSH DE
		PUSH BC
		PUSH AF
		LD SP,ARBST2
		RET
REGLAD:					; Register laden
		LD SP,REGRAM
		POP AF
		POP BC
		POP DE
		POP HL
		EXX
		EX AF,AF'		;'
		POP AF
		POP BC
		POP DE
		POP HL
		EXX
		EX AF,AF'		;'
		POP IX
		POP IY
		LD SP,ARBST2
		RET

		db 8 dup (?)

;-----------------------------------------------------

		;org 0B90h
; Stepfunktion
; zur Nutzung muss in 2340H JP STEPUP eingetragen werden 

STEPUP:
		LD HL,(USERPC)		; aktueller USER-PC
		PUSH HL			; merken
		LD HL,INTROUT		; Int-Routine
		LD (INTTAF),HL		; in Int-Tabelle schreiben
		LD A,0E9H		; cpl 16h
		LD (AREGST),A		; Register-Pointer auf "PC"
		LD HL,CTCPRG		; RET-Routine f. "ADR" 
		LD (STEPZEI),HL		; (Ende Registeranzeige)
; wird bei Start der Step-Funktion und dann bei Step (ADR) aufgerufen
CTCPRG:
		PUSH AF
		LD HL,(REGHL)		; HL merken f. INTROUT
		LD A,INTVEK		; INT-VECT. FUER CTC (00)
		OUT (CTC0),A
		LD A,85H		;Steuerwort
					;EI, Zeitgebermode
		OUT (CTC0),A
		LD A,04H		;ZK Zeitkonstante, 1 Befehl (4 Takte)
		OUT (CTC0),A
		IM 2
		LD A,HIINT		; Hi-Adr. INT-VECT. (23)
		LD I,A
		ADD A,0
		EI
		NOP
		POP AF
		RETI
; CTC wirft INT beim nchsten USER-Befehl
; INTROUT wird direkt danach aufgerufen 
INTROUT:
		DI
		PUSH AF
		LD A,03H
		OUT (CTC0),A		; INT aus
		POP AF
		LD (REGHL),HL		; HL restaurieren
		JP STARTST		; ab zur Registeranzeige

;-----------------------------------------------------
REGSYM:					; Reihenfolge passend zu Registerstack REGRAM ff.
		DEFB 4EH		; "F"
		DEFB 6FH		; "A"
		DEFB 0C6H		; "C"
		DEFB 0EAH		; "B"
		DEFB 0CEH		; "E"
		DEFB 0E9H		; "D"
		DEFB 0C2H		; "L"
		DEFB 06BH		; "H"
		DEFB 05EH		; "F."
		DEFB 07FH		; "A."
		DEFB 0D6H		; "C."
		DEFB 0FAH		; "B."
		DEFB 0DEH		; "E."
		DEFB 0F9H		; "D."
		DEFB 0D2H		; "L."
		DEFB 07BH		; "H."
		DEFB 04AH		; "X"
		DEFB 020H		; "i"
		DEFB 0ABH		; "Y"
		DEFB 020H		; "i"
		DEFB 04FH		; "P"
		DEFB 0AEH		; "S"
		DEFB 0C6H		; "C"
		DEFB 04FH		; "P"

		IF ROM_=1
		DEFB 05BH		;PRUEFSUMMENDIFFERENZ
		ENDIF

		IF ROM_=2
		DEFB 023H		;PRUEFSUMMENDIFFERENZ
		ENDIF

;---------------------------------------------------
		IF ROM_=1
		ORG 07FFH
		DEFB 0A1H		;PRUEFSUMME FUER 1-ROM-VARIANTE
		ENDIF

		IF ROM_=2
		ORG 0BFFH
		DEFB 071H		;PRUEFSUMME FUER 2-ROM-VARIANTE
		ENDIF


;***************************************************
;			RAM-ZELLEN

			ORG 22E2H

ARBST2:		DB 2 dup (?)		; Arbeitsstack2 Registeranzeige
ARBSTA:		Db 2 dup (?)		; Arbeitsstack Registeranzeige
REGRAM:		Db 2 dup (?)		; AF
		Db 2 dup (?)		; BC
		Db 2 dup (?)		; DE
REGHL:		Db 2 dup (?)		; HL
		Db 2 dup (?)		; AF'
		Db 2 dup (?)		; BC'
		Db 2 dup (?)		; DE'
		Db 2 dup (?)		; HL'
		Db 2 dup (?)		; IX
		Db 2 dup (?)		; IY
REGSP:		Db 2 dup (?)		; SP
REGPC:		Db 2 dup (?)		; PC
AREGST:		Db 2 dup (?)		; Registerstack
			; org 2300h
INTTAF:		Db 2 dup (?)		; INTROUT
STEPZEI:	Db 2 dup (?)		; RET-Routine nach Unterbrechung
AREGIN:		Db 2 dup (?)		; Wert anzuzeigendes Register

; RAM	2000H
; RST1:	2308H
; RST2:	2310H
; RST3:	2318H
; RST4:	2320H
; RST5:	2328H
; RST6:	2330H
; RST7:	2338H
; RST8:	2338H	; RSTUP STANDARD-RST38-PROG.
; NMI:	2340H	; NMIUP STANDARD-NMI-PROG.

		ORG 23EAH

SPINI		EQU $			;ANF.WERT FUER SP
TAPDIS:		Db 1 dup(?)		;DARZUSTELLENDES ZEICHEN BEI LOAD
FILNAME:	Db 2 dup(?)		;NAME DES ZU UEBERTR. PROG.
STARTADR: 	Db 2 dup(?)		; filename+2
ENDADRH:	Db 2 dup(?)		; filename+4
CHKSUMH:	Db 1 dup(?)		; filename+6
DATLED:		Db 2 dup(?)		;DATEN-ANZ.
ADRLED:		Db 4 dup(?)		;ADR.-ANZ.
USERPC:		Db 2 dup(?)		;ADRESSE
ATFLAG:		Db 1 dup(?)		; Aktionstastenflag, Kdo-Parametercode 0..3
					; ADRS, TO TAPE, FROM TAPE
ATCODE:		Db 1 dup(?)		; Aktionstastencode
					; 1-ADRS, 2-DATS, 6-TO TAPE, 7-FROM TAPE
INIFLAG:	Db 1 dup(?)		;INI-CODE, 80h-bereits initialisiert
FUFEFLAG: 	Db 1 dup(?)		;FUNKTIONS- UND FEHLERFLAG
					; Bit 0=1 Funktionstaste, Bit7=1 Fehler
FILE2:		Db 2 dup(?)		;NAME DES ZU LESENDEN PROG.

;*****************************************************
	END
